<?PHP
######################################################################################################
# This Script expects the exported phonebook from a Fritz!Box in XML format in the current directory #
# It converts and writes this to a Fanvil XML compatible phonebook, which can be placed on a server  #
# and used as cloud phonebook for WoWiFi phones.                                                     #
######################################################################################################
ini_set('display_errors', '1');
ini_set('error_reporting', E_ALL);

$file_fritz  = 'fritz.xml';
$file_fanvil = 'contact.xml';

function cleanContent($content) {
 #$content = substr($content, strpos($content, '<tr class="depboard-dark">')+26);
 #$content = deleteTextBetweenTags($content, '<a class="flap"','<div class="lc_sq_platform" headers="hafasSQPlatform">');
 #preg_replace('/<h3>(.*?)<\/h3>/', '<h3><span class="One">$1</span></h3>', $str);
 $content = str_replace (array("\r\n", "\n", "\r"), ' ', $content);
 $content = str_replace(' modified="0"','',$content);
 $content = str_replace(' quickdial=""','',$content);
 $content = str_replace(' vanity=""','',$content);
  
 $content = str_replace('<phonebooks>','',$content);
 $content = str_replace('</phonebooks>','',$content);
 $content = str_replace('<contact>',"\n".'<DirectoryEntry>',$content);
 $content = str_replace('</contact>',"\n".'</DirectoryEntry>',$content);
 $content = preg_replace('/<category>(.*?)<\/category>/', '', $content);
 $content = preg_replace('/<imageURL>(.*?)<\/imageURL>/', '', $content);
 $content = str_replace('<person><realName>',"\n".'<Name>',$content);
 $content = str_replace('</realName></person>','</Name>',$content);
 $content = preg_replace('/<telephony nid=(.*?)>/', '', $content);
 $content = str_replace('</telephony>','',$content);
 
 $content = preg_replace('/<number type="home"(.*?)>(.*?)<\/number>/', "\n".'<Telephone>$2</Telephone>', $content);
 $content = preg_replace('/<number type="mobile"(.*?)>(.*?)<\/number>/', "\n".'<Mobile>$2</Mobile>', $content);
 $content = preg_replace('/<number type="work"(.*?)>(.*?)<\/number>/', "\n".'<Other>$2</Other>', $content);
 
 $content = preg_replace('/<number (.*?) \/>/', '', $content); ## for empty numbers
 
 
 $content = preg_replace('/<services(.*?)<\/services>/', '', $content);
 $content = str_replace('<services />','',$content);
 $content = preg_replace('/<services nid=(.*?)>/', '', $content);
 
 $content = preg_replace('/<setup>(.*?)<\/setup>/', '', $content);
 $content = str_replace('<setup />','',$content);
 $content = preg_replace('/<mod_time>(.*?)<\/mod_time>/', '', $content);
 $content = preg_replace('/<uniqueid>(.*?)<\/uniqueid>/', '', $content);
 $content = preg_replace('/<features(.*?)>/', '', $content);
 
 $content = str_replace('<category />','',$content);
 $content = str_replace('<id>0</id>','',$content);

 $content = str_replace('  <phonebook>',"\n".'<PhoneBook>',$content);
 $content = str_replace('</phonebook>',"\n".'</PhoneBook>',$content);
 
 return $content;
}

echo '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html lang="de">
<head>
<title>Phonebook Converter Fritz!Box to Fanvil XML</title>
</head>
<body><h3>Converting...</h3>';

$content = file_get_contents($file_fritz);
$content = cleanContent($content);
file_put_contents($file_fanvil,$content);

echo '<h3>done</h3></body>
</html>';
?>
